<?php
# Grab POST variables
$campaign_name = trim($_POST['name']);
$campaign_title = trim($_POST['title']);
$campaign_pref = $_POST['ping_pref'];
$ping_pref = $campaign_pref;
$campaign_custom_urls = trim($_POST['custom_urls']);
$campaign_rss_url = trim($_POST['rss_url']);
$campaign_bk_urls = trim($_POST['bk_urls']);
$campaign_ip_addr = trim($_POST['ip_addr']);
$campaign_ref_sites = trim($_POST['ref_sites']);

# Start Validation
if (strlen($campaign_name) < 3 || strlen($campaign_name) > 50)
{
$err_msg[] = "Campaign Name is required (min. 3 characters/ maximum 50 characters)";
$err_count++;
}

if (strlen($campaign_title) < 6)
{
$err_msg[] = "Plz enter at least one Keyword (min. 6 characters)";
$err_count++;
}

$pref_array = array("self", "custom");
if (!in_array($campaign_pref, $pref_array))
{
$err_msg[] = "Plz. select a valid Pinging Preference";
$err_count++;
}


# Now validate optional fields
if (strlen($campaign_rss_url) > 2083)
{
$err_msg[] = "RSS URL needs to be less than 2083 characters";
$err_count++;
}

if ($campaign_pref == "custom")
{
if (strlen($campaign_custom_urls) < 12)
{
$err_msg[] = "Plz enter at least one url for custom pinging";
$err_count++;
}

else
{
# Form array of individual Custom URLs
$exp_campaign_custom_urls = array();
$exp_campaign_custom_urls = explode("\n", $campaign_custom_urls);

# Max. character check for each Custom URL
foreach ($exp_campaign_custom_urls as $check_custom_urls)
{
$check_custom_urls = trim($check_custom_urls);
if (strlen($check_custom_urls) > 2083)
{
$err_msg[] = "Custom URL - $check_custom_urls is greater than the allowed 2083 characters";
$err_count++;
}

if (strlen($check_custom_urls) < 12 && !empty($check_custom_urls))
{
$err_msg[] = "Custom URL - $check_custom_urls is less than the required minimum number of 12 characters";
$err_count++;
}
}

}
}

if (!empty($campaign_bk_urls))
{
# Form array of individual Backlinks URLs
$exp_campaign_bk_urls = array();
$exp_campaign_bk_urls = explode("\n", $campaign_bk_urls);

# Max. character check for each Backlink URL
foreach ($exp_campaign_bk_urls as $check_bk_urls)
{
$check_bk_urls = trim($check_bk_urls);
if (strlen($check_bk_urls) > 2083)
{
$err_msg[] = "Backlinks URL - $check_bk_urls is greater than the allowed 2083 characters";
$err_count++;
}
if (strlen($check_bk_urls) < 12 && !empty($check_bk_urls))
{
$err_msg[] = "Backlinks URL - $check_bk_urls is less than the required minimum number of 12 characters";
$err_count++;
}
}
}

if (!empty($campaign_ip_addr))
{
if (strlen($campaign_ip_addr) < 7)
{
$err_msg[] = "Invalid IP Address (Valid IP address is at least 7 characters)";
$err_count++;
}
else
{
# Form array of individual Backlinks URLs
$exp_campaign_ip_addr = array();
$exp_campaign_ip_addr = explode("\n", $campaign_ip_addr);

# Max. character check for each IP Address
foreach ($exp_campaign_ip_addr as $check_ip_addr)
{
$check_ip_addr = trim($check_ip_addr);
if (strlen($check_ip_addr) > 15)
{
$err_msg[] = "IP Address - $check_ip_addr is invalid (greater than 15 characters)";
$err_count++;
}

if (strlen($check_ip_addr) < 7 && !empty($check_ip_addr))
{
$err_msg[] = "IP Address - $check_ip_addr is invalid (less than 7 characters)";
$err_count++;
}
}
}
}

if (!empty($campaign_ref_sites))
{
# Form array of individual Referring URLs
$exp_campaign_ref_sites = array();
$exp_campaign_ref_sites = explode("\n", $campaign_ref_sites);

# Max. character check for each Referring Site
foreach ($exp_campaign_ref_sites as $check_ref_sites)
{
$check_ref_sites = trim($check_ref_sites);
if (strlen($check_ref_sites) > 2083)
{
$err_msg[] = "Referring Sites URL - $check_ref_sites is greater than the allowed 2083 characters";
$err_count++;
}
if (strlen($check_ref_sites) < 5 && !empty($check_ref_sites))
{
$err_msg[] = "Referring Sites URL - $check_ref_sites is less than the required minimum number of 5 characters";
$err_count++;
}
}
}


# Form array of individual Titles
$exp_campaign_title = array();
$exp_campaign_title = explode("\n", $campaign_title);

# Max. character check for each Title
foreach ($exp_campaign_title as $check_title)
{
$check_title = trim($check_title);
if (strlen($check_ref_sites) > 500)
{
$err_msg[] = "Keyword - $check_title is greater than the allowed 500 characters";
$err_count++;
}
}





if ($err_count > 0)
{
echo ("<div id='error'>
<h3>Oops! $err_count error(s) found</h3>
<ol>");
foreach ($err_msg as $err_disp)
{
echo ("<li>$err_disp</li>");
}
echo ("</ol></div>");
}
else
{
# Add campaign Details
# Create Unique ID
$enc_id = md5(microtime());
$enc_time = time();


# Sanitize data for DB Storage
$enc_name = strip_tags(addslashes($campaign_name));
$enc_rss_url = strip_tags(addslashes($campaign_rss_url));

# Ping Preference conversion to TINYINT
if ($ping_pref == "self")
{
$ping_pref_code = "0";
}
else
{
$ping_pref_code = "1";
}

global $wpdb;

# INSERT INTO Campaigns table
$insert_campaign = "INSERT INTO " . PINGAUTO_CAMPAIGNS_TBL . " (id, enc_id, name, ping_pref, rss_url, time, status) VALUES (NULL, '$enc_id', '$enc_name', '$ping_pref_code', '$enc_rss_url', '$enc_time', '1')";
$insert_campaign_res = $wpdb->query($wpdb->prepare($insert_campaign));

$campaign_id = $wpdb->insert_id;

# Now INSERT Campaign title(s)
foreach ($exp_campaign_title as $check_title)
{
$enc_title = strip_tags(addslashes($check_title));
if (!empty($enc_title))
{
$insert_title = "INSERT INTO " . PINGAUTO_TITLES_TBL . " (id, title) VALUES('$campaign_id', '$enc_title')";
$insert_res = $wpdb->query($wpdb->prepare($insert_title));
}
}

if ($ping_pref == "custom")
{
# INSERT custom URLS into urls table
foreach ($exp_campaign_custom_urls as $check_custom_url)
{
$enc_custom_url = strip_tags(addslashes($check_custom_url));
if (!empty($enc_custom_url))
{
$insert_url = "INSERT INTO " . PINGAUTO_URLS_TBL . " (id, url) VALUES('$campaign_id', '$enc_custom_url')";
$insert_url_res = $wpdb->query($wpdb->prepare($insert_url));
} 
}
}


if (!empty($campaign_bk_urls))
{
# INSERT backlinks into backlinks table
foreach ($exp_campaign_bk_urls as $check_bk_url)
{
$enc_bk_url = strip_tags(addslashes($check_bk_url));
if (!empty($enc_bk_url))
{
$insert_bk_url = "INSERT INTO " . PINGAUTO_BACKLINKS_TBL . " (id, url) VALUES('$campaign_id', '$enc_bk_url')";
$insert_bk_url_res = $wpdb->query($wpdb->prepare($insert_bk_url));
}
}
}


if (!empty($campaign_ip_addr))
{
foreach ($exp_campaign_ip_addr as $check_ip_addr)
{
$enc_ip_addr = trim(strip_tags(addslashes($check_ip_addr)));
if (!empty($enc_ip_addr))
{
$insert_ip_addr = "INSERT INTO " . PINGAUTO_IGNORE_IP_TBL . " (id, addr) VALUES('$campaign_id', INET_ATON('$enc_ip_addr'))";
$insert_ip_addr_res = $wpdb->query($wpdb->prepare($insert_ip_addr));
}
}
}

if (!empty($campaign_ref_sites))
{
foreach ($exp_campaign_ref_sites as $check_ref_site)
{
$enc_ref_site = strip_tags(addslashes($check_ref_site));
if (!empty($enc_ref_site))
{
$insert_ref_site = "INSERT INTO " . PINGAUTO_IGNORE_URLS_TBL . " (id, url) VALUES('$campaign_id', '$enc_ref_site')";
$insert_ref_site_res = $wpdb->query($wpdb->prepare($insert_ref_site));
}
}
}


echo ("
<div id='campaign_created'>
<h2>Campaign Created</h2>
<p>
This Ping campaign has been successfully created.</p>
</div>
");

# Remove slashes added by Wordpress
$campaign_name = stripslashes($campaign_name);
$campaign_title = stripslashes($campaign_title);
}
?>