<div id='pingauto_body'>
<?php
/*
This page is viewable if logged in as Wordpress Admin.
Each action has its own page (either in functions folder or includes folder)
We capture the action type from the $_GET variable
If no action is set - this page would render the list of Campaigns which is the default view
*/


if (!is_admin()) {
  echo ("<div id='error'>
  <h3>Permission Denied</h3>
  <p>You dont have the required permission to view this page</p>
  </div>");
  }
elseif($_GET['action'] == "edit") {
require(PINGAUTO_DIR . "includes/edit_campaign.php");
}
elseif($_GET['action'] == "delete") {
require(PINGAUTO_DIR . "functions/delete_campaign.php");
}
elseif($_GET['action'] == "pause") {
require(PINGAUTO_DIR . "functions/pause_campaign.php");
}
elseif($_GET['action'] == "restart") {
require(PINGAUTO_DIR . "functions/restart_campaign.php");
}
elseif($_GET['action'] == "reset") {
require(PINGAUTO_DIR . "functions/reset_stats.php");
}
elseif($_GET['action'] == "stats") {
require(PINGAUTO_DIR . "functions/show_stats.php");
}
else {
  ?>
  
<h1>Manage Campaigns</h1>


<?php
if ($_GET['return'] == "err")
{
$msg_head = base64_decode($_GET['head']);
$msg_body = base64_decode($_GET['body']);
echo ("<div id='error'>
<h2>$msg_head</h2>
<p>$msg_body</p>
</div>
");
}
if ($_GET['return'] == "succ")
{
$msg_head = base64_decode($_GET['head']);
$msg_body = base64_decode($_GET['body']);
echo ("<div id='success'>
<h2>$msg_head</h2>
<p>$msg_body</p>
</div>
");
}
?>


<?php
#Pagination start
//This checks to see if there is a page number. If not, it will set it to page 1
$pagenum = $_GET['pagenum'];
if (!(isset($pagenum)))
{
$pagenum = 1;
}

//This is the number of results displayed per page
$page_rows = 25;

//This sets the range to display in our query
$max = 'limit ' .($pagenum - 1) * $page_rows .',' .$page_rows;

global $wpdb;

$query1 = "SELECT * FROM " . PINGAUTO_CAMPAIGNS_TBL . " ORDER BY id DESC $max";
$result1 = $wpdb->get_results($query1, ARRAY_A);
$rows = $wpdb->num_rows;

$query2 = "SELECT * FROM " . PINGAUTO_CAMPAIGNS_TBL . " ORDER BY id DESC";
$result2 = $wpdb->get_results($query2, ARRAY_A);
$rows2 = $wpdb->num_rows;

//This tells us the page number of our last page
$last = ceil($rows2/$page_rows);

//this makes sure the page number isn't below one, or more than our maximum pages
if ($pagenum < 1)
{
$pagenum = 1;
}
elseif ($pagenum > $last)
{
$pagenum = $last;
}



if ($rows == 0)
{
echo ("<div id ='error'>
<h2>No Campaigns</h2>
<p>Either no Ping Campaigns have been added as of yet or the database is down.</p>
</div>
");
}
else
{
echo ("<p class=\"center\"><strong>Showing Page # $pagenum of $last (Total No. of Campaigns: $rows2)</strong>
</p>");

// First we check if we are on page one. If we are then we don't need a link to the previous page or the first page so we do nothing. If we aren't then we generate links to the first page, and to the previous page.
if ($pagenum == 1)
{
echo ("<p class=\"center\">");
}
else
{
echo "<p class=\"center\"><a href='{$_SERVER['PHP_SELF']}?page=pingautomatic-manage-campaigns&pagenum=1' class='paginate_links'> << First</a> ";
echo " ";
$previous = $pagenum-1;
echo " <a href='{$_SERVER['PHP_SELF']}?page=pingautomatic-manage-campaigns&pagenum=$previous' class='paginate_links'> < Previous</a> ";
}

if ($pagenum > 1 && $pagenum != $last)
{
//just a spacer
echo " ---- ";
}

//This does the same as above, only checking if we are on the last page, and then generating the Next and Last links
if ($pagenum == $last)
{
echo ("</p>");
}
else {
$next = $pagenum+1;
echo " <a href='{$_SERVER['PHP_SELF']}?page=pingautomatic-manage-campaigns&pagenum=$next' class='paginate_links'>Next ></a> ";
echo " ";
echo " <a href='{$_SERVER['PHP_SELF']}?page=pingautomatic-manage-campaigns&pagenum=$last' class='paginate_links'>Last >></a></p> ";
}

echo ("
<div id=\"admin_table\">
<table align='center' border='1'>
<tr>
<th>Campaign Name</th><th>Pinging Preference</th><th>RSS URL</th><th>Creation Time</th><th>Status</th><th class='action_width'>Action</th><th>View</th>
</tr>
");

foreach ($result1 as $row)
{
$id = $row['id'];
$enc_id = $row['enc_id'];
$campaign_name = stripslashes($row['name']);
$ping_pref = $row['ping_pref'];


if ($ping_pref == "0")
{
$pref_display = "Self Pinging";
}
else
{
$pref_display = "Custom URLs Pinging";
}
$rss_url = $row['rss_url'];
$rss_url_code = base64_encode($rss_url);

if (empty($rss_url))
{
$rss_url = "<span class='center'>--</span>";
}

$status = $row['status'];
if ($status == 1)
{
$status_display = "<span class='active_campaign'>Active</span>";
$variable_action = "<a href='" . $_SERVER['PHP_SELF'] . "?page=pingautomatic-manage-campaigns&action=pause&id=$id&change=2'>Pause</a>";
}
else
{
$status_display = "<span class='paused_campaign'>Paused</span>";
$variable_action = "<a href='" . $_SERVER['PHP_SELF'] . "?page=pingautomatic-manage-campaigns&action=restart&id=$id&change=1'>Restart</a>";
}

$time = $row['time'];
$time_display = date("r", $time);


# Create action specific URLs
$edit_campaign_url = $_SERVER['PHP_SELF'] . "?page=pingautomatic-manage-campaigns&action=edit&id=$id";
$delete_campaign_url = $_SERVER['PHP_SELF'] . "?page=pingautomatic-manage-campaigns&action=delete&id=$id";
$reset_campaign_url = $_SERVER['PHP_SELF'] . "?page=pingautomatic-manage-campaigns&action=reset&id=$id";
$campaign_stats_url = $_SERVER['PHP_SELF'] . "?page=pingautomatic-manage-campaigns&action=stats&id=$id";
$rss_feed_url = site_url() . "/?feed=pingautomatic-rss&id=$enc_id"; 


echo ("
<tr>
<td>$campaign_name</td><td>$pref_display</td><td>$rss_url</td><td>$time_display</td><td>$status_display</td>
<td><a href='$edit_campaign_url'>Edit</a><br />
<a href='#' onclick=\"delete_confirm('$delete_campaign_url');\">Delete</a><br />
$variable_action<br />
<a href='#' onclick=\"reset_stats('$reset_campaign_url');\">Reset Stats</a></td>
<td><a href='$campaign_stats_url'>Stats</a><br />
<a href='$rss_feed_url' target='_blank'>Feed</a></td>
</tr>
");
}

echo ("</table></div>");
}



?>


<p align='center'><iframe src="http://auto-pinger.empiremarketing.ca/123/viewcampaigns.php" border="0" width="600" height="100" scrolling="no" style="border:0px;margin:0px;padding:0px;"></iframe></p>

  
<?php  
}
?>
</div>